package com.ensign.crm.module.crm.service;

import com.ensign.crm.module.crm.model.ImageStorage;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.concurrent.TimeUnit;

/**
 * @Description: TODO
 * @Date: 2024/9/27 15:09
 * @Created: by ZZSLL
 */


@Service
@Slf4j
public class ImageService {

    @Resource
    private RedisTemplate<String, ImageStorage> redisTemplate;

    private final String CACHE_PREFIX = "kingdee:temp_file";

    public byte[] downloadImage(String imageUrl) throws IOException {
        CloseableHttpClient httpClient = HttpClients.createDefault();
        HttpGet httpGet = new HttpGet(imageUrl);
        CloseableHttpResponse response = httpClient.execute(httpGet);

        try {
            ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
            response.getEntity().writeTo(outputStream);
            return outputStream.toByteArray();
        } finally {
            response.close();
            httpClient.close();
        }
    }

    public void saveImage(String key, ImageStorage imageData) {
        redisTemplate.opsForValue().set(CACHE_PREFIX + key, imageData, 2, TimeUnit.HOURS);
    }

    public ImageStorage getImage(String key) {
        return redisTemplate.opsForValue().get(CACHE_PREFIX + key);
    }
}
